begin
  require 'airbrake'
rescue LoadError
  raise "Can't find 'airbrake' gem. Please add it to your Gemfile or install it."
end

module ResqueAdmin
  module Failure
    class Airbrake < Base
      def self.configure(&block)
        ResqueAdmin.logger.warn "This actually sets global Airbrake configuration, " \
          "which is probably not what you want."
        ResqueAdmin::Failure.backend = self
        ::Airbrake.configure(&block)
      end

      def self.count(queue = nil, class_name = nil)
        # We can't get the total # of errors from Airbrake so we fake it
        # by asking ResqueAdmin how many errors it has seen.
        Stat[:failed]
      end

      def save
        ::Airbrake.notify(exception,
            :parameters => {
            :payload_class => payload['class'].to_s,
            :payload_args => payload['args'].inspect
            }
          )
      end
    end
  end
end
